## dgit 0.21

=== Makefile ===
# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

INSTALL=install
INSTALL_DIR=$(INSTALL) -d
INSTALL_PROGRAM=$(INSTALL) -m 755
INSTALL_DATA=$(INSTALL) -m 644

prefix?=/usr/local

bindir=$(prefix)/bin
mandir=$(prefix)/share/man
man1dir=$(mandir)/man1

PROGRAMS=dgit
MAN1PAGES=dgit.1

all:

install:	installdirs
	$(INSTALL_PROGRAM) $(PROGRAMS) $(DESTDIR)$(bindir)
	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)

installdirs:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(man1dir)

check installcheck:

clean distclean mostlyclean maintainer-clean:

## dgit 0.20

=== debian/changelog ===
dgit (0.20) unstable; urgency=high

  * Use newest (not oldest) version currently in suite when calculating
    what value to use for -v<version> by default.  Closes:#732781.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 21 Dec 2013 19:13:56 +0000

dgit (0.19) unstable; urgency=low

  Testing facilities:
  * Provide "test-dummy" distro with "dummycat" access method.
  * Provide a selection of autopkgtest (DEP-8) tests.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 27 Nov 2013 18:27:17 +0000

dgit (0.18.2) unstable; urgency=high

  Bump archive upload urgency to high.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 24 Nov 2013 17:42:57 +0000

dgit (0.18.1) unstable; urgency=low

  Bugfixes:
  * sshpsql archive query method passes LANG=C.  Closes:#729788.
  * Subcommand program or argument options containing hyphens work.
    (Eg, --dpkg-buildpackage:blah was previously incorrectly rejected.)

  Packaging fixes:
  * Depend on dput.
  * Depend on curl | wget, as dget needs one of those.  (The dput package,
    which contains dget, doesn't require them because dput itself works
    without.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 24 Nov 2013 17:36:03 +0000

dgit (0.18) unstable; urgency=low

  Major new feature:
  * Remote push (dgit rpush), a la debsign -r.  Closes:#721185.

  Improved behaviours:
  * dgit build, by default, uses the archive to find out what the correct
    -v<version> option is to pass to dpkg-genchanges.  Closes:#727200.
  * Abolish the sshdakls method and replace it with sshpsql: that is, ssh
    (to coccia, by default) and run sql commands on the ftpmaster
    database.  This is faster and has fewer bugs but is vulnerable to db
    schema changes.  Closes:#726955.  Closes:#720170.  Closes:#720176.
  * When generating git tags, quote the (uncanonicalised) changelog's
    Distribution field as the suite.
  * Command execution reports from --dry-run go to stderr.

  Other new features:
  * Support --gpg=... to provide a replacement command for gpg.
  * Support --ssh=... and --ssh:... to affect how we run ssh.

  Bugfixes:
  * When using sbuild, pass the arguments to mergechanges in the right
    order so that we use the correct Description (the _source one,
    not the one from sbuild which didn't get e.g. -v<version>).
  * push actually takes an optional suite, like it says in the synopsis.
    Closes:#727125.
  * Fix dgit --damp-run sbuild to actually work.
  * Fix the "shellquote" internal subroutine.  The bugs in it ought not to
    have caused any real trouble in previous versions of dgit.

  Documentation and message fixes:
  * manpage: Clarify comments about orig tarballs.  Closes: #723605.
  * manpage: Remove comment in BUGS about lack of policy docs
    for Dgit field, which is specified now.  Closes:#720201.
  * manpage: Make discussion of --existing-package less scary.  The
    default archive access method no longer needs it.  Closes:#720171.
  * Mention "git merge", not "git-merge", in helpful message.
    Closes:#725632.

  Internal and debugging improvements:
  * Report chdir actions in debugging output.
  * Improvements to implementation of --dry-run and --damp-run.
  * Some code motion and cleanups.

  Note: changelog entries for the following versions, which were uploaded
  to Debian experimental, have been collapsed into this single entry:
    0.18~experimental2 0.18~experimental1
    0.17~experimental7 0.17~experimental6 0.17~experimental5
    0.17~experimental4 0.17~experimental3 0.17~experimental2
    0.17~experimental1
    0.16~experimental3 0.16~experimental2 0.16~experimental1
  We do describe here all the changes since 0.17.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 09 Nov 2013 10:12:13 +0000

dgit (0.17) unstable; urgency=high

  * Do not grobble around in .git/refs/; instead, use git-show-ref.
    This avoids breaking when git makes packed refs.  Closes:728893.
  * Clarify error message for missing refs/remotes/dgit/dgit/<suite>.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 07 Nov 2013 00:02:47 +0000

dgit (0.16) unstable; urgency=high

  * Format `(3.0) quilt' fixup does not mind extraneous other files
    in the build tree (e.g., build products and logs).  Closes: #727053.
  * Set autoflush on stdout, to get better ordering of debugging
    etc. output when stdout is redirected.
  * New --damp-run mode, for more convenient and fuller testing etc.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 22 Oct 2013 13:06:54 +0100

dgit (0.15) unstable; urgency=low

  * Better handling of packages pushed using dgit and stuck in NEW.
    (And, use of `--new' is not needed with fetch.)  Closes: #722199.
  * More comprehensive warnings in many cases of archive skew.
  * Implement `dgit help' as well as `--help'.  Closes: #721661.
  * Provide `dgit version' and `--version'.  Closes: #721654.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 12 Sep 2013 00:14:05 +0100

dgit (0.14) unstable; urgency=low

  * Include package name in tag message.
  * Create directory .git/dgit when needed during build.  Closes: #721428.
  * Add Vcs-Git and Vcs-Browser [Richard Hartmann].  Closes: #721404.
    These fields refer to the development branch, "master", on alioth,
    not to the dgit suite refs (which are not accessible to git clone).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 01 Sep 2013 18:30:44 +0100

dgit (0.13) unstable; urgency=low

  * Reuse already-downloaded .orig files after checking their hashes.
    Closes: #720526.  (This introduces a dependency on Digest::SHA.)
  * Do not always pointlessly fetch the .dsc twice.  (That code was
    erroneously duplicated during editing, apparently.)
  * Remove DGET_UNPACK from the environment in case the user has set it.
  * Remove scary warning from Description.
  * When uploading to Debian, tell dput to upload to "ftp-master".  This
    avoids problems with derivatives whose dput has a different default.


=== debian/control ===
Source: dgit
Section: devel
Priority: optional
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Standards-Version: 3.9.4.0
Build-Depends: debhelper (>= 9)
Vcs-Git: git://anonscm.debian.org/dgit-repos/repos/dgit.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=dgit-repos/repos/dgit.git

Package: dgit
Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
         ${misc:Depends}, realpath, libdigest-sha-perl, dput, curl | wget
Recommends: ssh-client
Suggests: sbuild
Architecture: all
Description: git interoperability with the Debian archive
 dgit (with the associated infrastructure) makes it possible to
 treat the Debian archive as a git repository.
 .
 dgit push constructs uploads from git commits
 .
 dgit clone and dgit fetch construct git commits from uploads.

=== debian/tests/control ===
Tests: clone-nogit fetch-localgitonly fetch-somegit-notlast push-newpackage push-nextdgit quilt
Tests-Directory: tests/tests
Depends: @, devscripts

## dgit 0.21

=== debian/changelog ===
dgit (0.21) unstable; urgency=medium

  Bugfixes relating to unclean trees:
  * Run a clean (of the specified type) before any build operation; do
    this with `dpkg-buildpackage -T' clean if necessary, so -wd now works
    with all the building methods.
  * Refuse to do quilt fixup (explicitly requested, or as a result of
    build) if the tree contains ignored files.  Closes:#731632.

  Error message improvements:
  * Use failedcmd to report errors when ssh psql fails.  Closes:#734281.
  * failedcmd prints $us, not $_[0] - ie, dgit doesn't pretend,
    in the error message, to be its child.
  * Do not report the (irrelevant) $? when madison parsing fails.

  Better workflow flexibility:
  * Provide --build-products-dir option (and corresponding semantics
    for -C) to specify where to find the files to upload.  Closes:#731633.

  Support for Debian backports suites:
  * New quirks infrastructure in configuration and internals,
    for suites (or perhaps distros) which are a bit like others.
  * Use correct default archive location.
  * Compute "-v" option default value correctly.
  * Closes:#733954.

  Packaging improvement:
  * Add `Testsuite: autopkgtest' to debian/control.  (This will only have
    the right effect with recent enought dpkg; it will generate a harmless
    warning with earlier versions of dpkg.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 19 Jan 2014 02:14:25 +0000

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
 Standards-Version: 3.9.4.0
 Build-Depends: debhelper (>= 9)
+Testsuite: autopkgtest
 Vcs-Git: git://anonscm.debian.org/dgit-repos/repos/dgit.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=dgit-repos/repos/dgit.git

=== debian/rules ===
#!/usr/bin/make -f

# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

export prefix=/usr

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol
	set -e; \
	 cd debian/dgit; \
	 v=$$(perl -ne 'print if s/^version:\s+//i' DEBIAN/control); \
	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit

=== debian/tests/control ===
Tests: clone-nogit fetch-localgitonly fetch-somegit-notlast push-newpackage push-nextdgit quilt push-buildproductsdir
Tests-Directory: tests/tests
Depends: @, devscripts

## dgit 0.22~bpo70+1

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 mandir=$(prefix)/share/man
 man1dir=$(mandir)/man1
 
-PROGRAMS=dgit
+PROGRAMS=dgit dgit-repos-server
 MAN1PAGES=dgit.1
 
 all:

=== debian/changelog ===
dgit (0.22~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Add myself to uploaders. 

 -- Holger Levsen <holger@debian.org>  Thu, 18 Sep 2014 16:35:00 +0000

dgit (0.22) unstable; urgency=medium

  Bugfixes:
  * Clone removes destination directory on error.  Closes:#736153.
  * Work with wheezy-backports (and keep squeeze-backports working too).
    Closes:#736524.
  * Work in read-only no-git-history mode with Ubuntu.  You still have
    to pass -dubuntu.  Closes:#751781.
  * Use mirror.ftp-master.debian.org DNS alias rather than coccia.
    Closes:#752602.
  * Check hashes of files ourselves rather than running dget to
    re-retreive the .dsc.
  * Check SHA-256 of .dsc against hash from archive_query (ie projectb)
    rather than letting dpkg-source do a signature verification.
    Closes:#737619.  Closes:#737625.
  * Treat .dsc as bytes, just like everything else, rather than letting
    HTTP::Message convert it to a Perl unicode string which the rest of
    the program mishandles.  Closes:#738536.

  Minor improvements:
  * Include canonicalised suite name in signed tag message.
  * Mention cross-version dgit rpush incompatibility in manpage.
  * Check for rpush protocol version incompatibility and crash early
    if incompatible.
  * New script tests/using-intree for running tests on the source tree.
  * Do not spew diff output to terminal (by default).  Print sensible
    message instead.  Closes:#736526.
  * Print better message for lack of configuration settings.
  * Document that dgit rpush needs gnupg and your public key on the build
    host.  Closes:#736529.
  * Fix a manpage reference to `--dget=' where `--dgit=' was intended.
  * Provide t-archive-process-incoming and t-archive-query subroutines for
    regression test scripts to use.
  * Print better message for unknown operations.
  * Provide `dgit clean'.  Closes:#736527.
  * When cloning, set up a remote `vcs-git' from the package's Vcs-Git
    (and put an appropriate caveat in the manpage).  Closes:#740687.
    Closes:#740721.
  * Improve error message for .dsc having already been signed (iff
    using libdpkg-perl 1.17.x).  Closes:#731635.
  * Improve error message for .dsc parsing failures more generally.
  * Better reporting of child exit statuses (esp. deaths due to signals).
  * In rpush, on protocol error talking to build host, check if the
    subprocess died and report differently if so.  Closes:#736528.
  * Fixed a manpage typo.
  * When tests invoke dgit, use --dgit= so that subprocesses use our
    dgit rather than system one.
  * Add a test for dgit rpush.

  Major new feature, currently stalled awaiting server infrastructure:
  * dgit-repos-server: New program for receiving signed-tag-based
    pushes.  Corresponding support in dgit itself, but not currently
    used by default for any distro.
  * Bring forward push of the version tag ref so it happens alongside
    the push of the suite branch ref.
  * New git-check and git-create methods "true" which are no-ops.
  * test-dummy-drs `distro': for testing dgit and dgit-repos-server.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 19 Aug 2014 11:24:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
+Uploaders: Holger Levsen <holger@debian.org>
 Standards-Version: 3.9.4.0
 Build-Depends: debhelper (>= 9)
 Testsuite: autopkgtest

## dgit 0.22.1

=== debian/changelog ===
dgit (0.22.1) unstable; urgency=high

  * Use Dpkg::Version::version_compare everywhere, not
    Dpkg::Version::version_compare_string.  The latter is entirely wrong,
    meaning that dgit would get many version comparisons wrong.
    Closes:#768038.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 04 Nov 2014 12:46:40 +0000

## dgit 1.3

=== debian/changelog ===
dgit (1.3) unstable; urgency=high

  Important bugfixes:
  * In option parser test `@ARGV' not `length @ARGV'.  Closes:#795710.
  * Properly quote package name when constructing regexp in
    complete_file_from_dsc.  Closes:#795736.  Also, grep the code for
    likely similar problems elsewhere and improve a (harmless) instance in
    dgit-repos-server.

  Other improvements:
  * If a .orig in .. is a symlink, hardlink the link target into our
    private unpack directory, rather than the link itself (since latter
    won't work if the symlink is relative).  Closes:#795665.
  * Test suite: Fix t-restriction-x-dgit-schroot-build in non-adt mode.
  * Infrastructure: Improve an error message in dgit-repos-policy-debian.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Aug 2015 17:51:02 +0100

dgit (1.2) unstable; urgency=high

  Improvements:
  * Honour *.clean-mode configuration setting for --clean= mode.
  * No longer require option values to be cuddled: support `--opt val' and
    `-o val'.  Closes:#763332.

  Manpages:
  * Fix typos.
  * Document that tags are in DEP-14 format, and that they
    are used for authenticating pushes.
  * Correct cross-reference to point to browse.d.d.o.
  * Move dgit.default.* to main CONFIGURATION section.

  Administrivia:
  * Add missing close of #793060 to changelog for version 1.1.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 14 Aug 2015 18:27:20 +0100

dgit (1.1) unstable; urgency=medium

  Bugfixes:
  * When source package contains things called .git (even files, and even
    in subdirectories), remove them.  Closes:#793671.
  * Work around curl -sS -I printing `HTTP/1.0 200 Connection established'
    before the actual header, so dgit works with https_proxy set (!)
  * --new is needed for read access to packages in NEW, too.  Document
    this, and make it work properly.
  * Work around #793471 (madness with $SIG{__WARN__} and Perl's system
    builtin): move $SIG{} setting into setup_sigwarn in Dgit.pm, and
    check getppid.
  * When invoking git-buildpackage via dgit gbp-build, consider our
    command line arguments when massaging the dpkg-buildpackage arguments,
    so that we don't end up giving dpkg-buildpackage contradictory
    instructions.
  * Cope with new git-buildpackage which provides gbp, rather than the
    eponymous command, on PATH.

  Configurability:
  * Honour dgit-distros.DISTRO.cmd-CMD and .opts-CMD.  Closes:#793427.
  * Make configuration able to prevent dpkg-mergechangelogs setup.
  * Provide dgit setup-new-tree (like dpkg-setup-mergechangelogs
    but only does it if not disabled in config).
  * Set up git user.email and user.name from distro access config
    or DEBEMAIL/DEBFULLNAME.  Closes:#793410.
  * When key to use not specified any other way, use the debian/changelog
    trailer line.  Closes:#793423.
  * Honour --git= (mostly).

  Documentation:
  * Fix some manpage typos.  [ Richard Hartmann ]
  * Manpage said that --clean=check was -wn but that is --clean=none;
    correctly document that --clean=check is actually -wc.
  * Document that up to -DDDD (not just -DD) is meaningfully different.
  * Document that -cname=value applies only for this run.
  * Improve manpage comment about defining a new distro.
  * Document that --quilt=linear is the default for Debian.
  * Fix a formatting problem in --build-products-dir= doc.
  * In manpage, do not seem to imply that NMU should be of only one
    new commit.
  * Qualify to Debian the manpage comment about how to do NMU.
  * In discussion on how to start using dgit when already using git, do
    not imply/assume that existing git history will have identical trees
    to dgit history.
  * Remove stray sentence in config section of manpage.
  * Manpage: Clarify wording of readonly config.
  * Manpage: Better cross-references for -k and keyid.
  * dgit(7): No longer say that dgit-repos lives on Alioth.

  Improvements:
  * Introduce more sophisticated protocol negotiation for rpush.
  * Do not quote `:' in shellquote.
  * Print a supplementary message when push fails, giving advice to
    the user about how to retry.  Closes:#793144.
  * Slurp in entire git config, for better performance.
  * Rename `git-build' operation to `gbp-build' to make it clearer what
    it's for.  Keep the old name as an alias.
  * Show `dgit sbuild' in usage message.
  * When we are using dpkg-buildpackage to clean before using it to also
    do the build, let it do its cleaning thing as part of its run, rather
    than running it twice.  When we are _not_ supposed to be using
    dpkg-buildpackage to clean, but we are running it to do the build,
    pass -nc.  Closes:#793060.
  * Also suppress spurious runs of the clean target when building using
    git-buildpackage.
  * When exec fails, always print the program name in the error message.

  Infrastructure:
  * Infrastructure: Get mirroring right for fresh repos of existing
    packages (!)

  Packaging, cleanups, debugging and test suite:
  * Fix Vcs-Git and Vcs-Browse to refer to chiark.  (The dgit-repos on
    alioth aren't suitable right now because the master there can
    currently only be updated with an actual upload, ie dgit push.)
  * Make warnings fatal in dpkg-repos-admin-debian, dgit-ssh-dispatch
    (using setup_sigwarn).
  * Make warnings fatal in tstunt/dpkg-parsechangelog (directly).
  * Test suite: Honour DGIT_TEST_DEBUG=''.
  * With -DDDD, print out all gitcfg references (copious!)
  * Fix a debug message in the obsolete sshpsql archive access driver.
  * Test suite: More automatic enumeration of tests.
  * Test suite: Provide tests which check that all our various build
    operations run the right targets as expected (ie, that we are massaging
    the arguments to dpkg-buildpackage, and suppressing our clean target,
    etc., correctly).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 27 Jul 2015 16:34:31 +0100

dgit (1.0) unstable; urgency=medium

  Improvements:


## dgit 1.4

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # dgit
 # Integration between git and Debian-style archives
 #
-# Copyright (C)2013 Ian Jackson
+# Copyright (C)2013-2015 Ian Jackson
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,20 +25,51 @@
 
 bindir=$(prefix)/bin
 mandir=$(prefix)/share/man
+perldir=$(prefix)/share/perl5
 man1dir=$(mandir)/man1
+man7dir=$(mandir)/man7
+infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
 
-PROGRAMS=dgit dgit-repos-server
+PROGRAMS=dgit
 MAN1PAGES=dgit.1
+MAN7PAGES=dgit.7
+PERLMODULES=Debian/Dgit.pm
+
+INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
+	dgit-repos-policy-debian dgit-repos-admin-debian \
+	dgit-repos-policy-trusting dgit-mirror-rsync
+INFRA_EXAMPLES=get-dm-txt ssh-wrap drs-cron-wrap get-suites
+INFRA_PERLMODULES=Debian/Dgit/Policy/Debian.pm
 
 all:
 
 install:	installdirs
 	$(INSTALL_PROGRAM) $(PROGRAMS) $(DESTDIR)$(bindir)
 	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)
+	$(INSTALL_DATA) $(MAN7PAGES) $(DESTDIR)$(man7dir)
+	set -e; for m in $(PERLMODULES); do \
+		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
+	done
 
 installdirs:
-	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(man1dir)
+	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
+		$(DESTDIR)$(man1dir) $(DESTDIR)$(man7dir) \
+		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))
+
+install-infra:	installdirs-infra
+	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_PROGRAMS)) \
+		$(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_EXAMPLES)) \
+		$(DESTDIR)$(infraexamplesdir)
+	set -e; for m in $(INFRA_PERLMODULES); do \
+		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
+	done
+
+installdirs-infra:
+	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(infraexamplesdir) \
+		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))
 
 check installcheck:
 
 clean distclean mostlyclean maintainer-clean:
+	rm -rf tests/tmp

=== tests/Makefile ===
# usage: tests/using-intree make -f tests/Makefile
# (optionally setting TESTSCRIPTS='tests/tests/foo tests/tests/bar')

TESTSCRIPTS ?= $(shell tests/enumerate-tests)
TESTNAMES := $(notdir $(TESTSCRIPTS))

all: $(foreach t,$(TESTNAMES),tests/tmp/$t.ok)
	@echo "ALL PASSED"

tests/tmp:
	mkdir -p $@

tests/tmp/%.ok: tests/tmp
	tests/tests/$* >tests/tmp/$*.log 2>&1

=== debian/changelog ===
dgit (1.4) unstable; urgency=high

  Bugfixes:
  * Unbreak --dry-run (`exiting subroutine via next', broken in
    ac221d67, bug released in 0.22).
  * When running git-add in commit-quilty-patch, properly escape
    filenames (which git-add treats as glob patterns).
  * When running git-add in commit-quilty-patch, use -f and sometimes -A,
    so as to avoid being broken by any .gitignore, etc.
  * When quilt linearisation fails, print the right information in
    the error message.  (This has been broken forever.)
  * Cope properly with `3.0 (quilt)' with single-debian-patch.
    Closes:#796016.  (Still does not work with wheezy's dpkg-source, so
    no test case yet.)
  * With dgit sbuild, pass our -d before the user's arguments, so that
    the user can override it.  Closes:#796019.

  New checks and improved behaviours:
  * Detect and reject git trees containing debian/source/local-options
    or debian/source/local-patch-header.
  * In --dry-run mode, _do_ actually run dpkg-source --commit so that we
    actually do construct the quilt fixup commit; instead, honour
    --dry-run by avoiding pulling it back to your HEAD.
  * quilt-fixup checks that the git tree is clean, as for build-prep.

  Documentation:
  * In dgit(7), discuss binaries and documentation present in upstream but
    removed by rules clean.

  Test suite:
  * Run quilt-fixup with -wgf in distropatches-reject,
    so that we don't need build-depends.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 22 Aug 2015 15:31:02 +0100

=== debian/control ===
Source: dgit
Section: devel
Priority: optional
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Standards-Version: 3.9.4.0
Build-Depends: debhelper (>= 9)
Testsuite: autopkgtest
Vcs-Git: git://git.chiark.greenend.org.uk/~ianmdlvl/dgit.git
Vcs-Browser: http://www.chiark.greenend.org.uk/ucgi/~ianmdlvl/git/dgit.git/

Package: dgit
Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
         ${misc:Depends},
         coreutils (>= 8.23-1~) | realpath,
         libdigest-sha-perl, dput, curl,
         libjson-perl, ca-certificates
Recommends: ssh-client
Suggests: sbuild
Architecture: all
Description: git interoperability with the Debian archive
 dgit (with the associated infrastructure) makes it possible to
 treat the Debian archive as a git repository.
 .
 dgit push constructs uploads from git commits
 .
 dgit clone and dgit fetch construct git commits from uploads.

Package: dgit-infrastructure
Depends: ${misc:Depends}, perl, git-core, dgit, gpgv, chiark-utils-bin,
         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3
Architecture: all
Priority: extra
Description: dgit server backend infrastructure
 This package contains tools which are useful for setting up a dgit
 git repository server.  You probably want dgit, the client package.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # dgit
 # Integration between git and Debian-style archives
 #
-# Copyright (C)2013 Ian Jackson
+# Copyright (C)2013-2015 Ian Jackson
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,3 +29,13 @@
 	 cd debian/dgit; \
 	 v=$$(perl -ne 'print if s/^version:\s+//i' DEBIAN/control); \
 	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit
+
+override_dh_auto_install:
+	make install prefix=/usr DESTDIR=debian/dgit
+	make install-infra prefix=/usr DESTDIR=debian/dgit-infrastructure
+
+debian/tests/control: tests/enumerate-tests debian/tests/control.in
+	$< gencontrol >$@.new && mv -f $@.new $@
+
+debian/tests/control: tests/lib-core tests/lib-restricts
+debian/tests/control: tests/tests $(wildcard tests/tests/*[^~#])

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, git-buildpackage

Tests: build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, sbuild
Restrictions: x-dgit-schroot-build

Tests: dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, rsync

Tests: build-modes clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject distropatches-reject drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast push-buildproductsdir push-newpackage push-nextdgit quilt rpush tag-updates test-list-uptodate trustingpolicy-replay
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts

## dgit 2.13

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # dgit
 # Integration between git and Debian-style archives
 #
-# Copyright (C)2013-2015 Ian Jackson
+# Copyright (C)2013-2016 Ian Jackson
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,24 +29,46 @@
 man1dir=$(mandir)/man1
 man7dir=$(mandir)/man7
 infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
+txtdocdir=$(prefix)/share/doc/dgit
+absurddir=$(prefix)/share/dgit/absurd
 
 PROGRAMS=dgit
 MAN1PAGES=dgit.1
-MAN7PAGES=dgit.7
+
+MAN7PAGES=dgit.7				\
+	dgit-user.7 dgit-nmu-simple.7		\
+	dgit-maint-native.7			\
+	dgit-maint-merge.7 dgit-maint-gbp.7	\
+	dgit-sponsorship.7
+
+TXTDOCS=README.dsc-import
 PERLMODULES=Debian/Dgit.pm
+ABSURDITIES=git
 
 INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
 	dgit-repos-policy-debian dgit-repos-admin-debian \
 	dgit-repos-policy-trusting dgit-mirror-rsync
 INFRA_EXAMPLES=get-dm-txt ssh-wrap drs-cron-wrap get-suites
-INFRA_PERLMODULES=Debian/Dgit/Policy/Debian.pm
+INFRA_PERLMODULES= \
+	Debian/Dgit.pm \
+	Debian/Dgit/Infra.pm \
+	Debian/Dgit/Policy/Debian.pm
 
-all:
+all:	$(MAN7PAGES) $(addprefix substituted/,$(PROGRAMS))
 
-install:	installdirs
-	$(INSTALL_PROGRAM) $(PROGRAMS) $(DESTDIR)$(bindir)
+substituted/%:	%
+	mkdir -p substituted
+	perl -pe 's{\bundef\b}{'\''$(absurddir)'\''} if m/###substituted###/' \
+		<$< >$@
+
+install:	installdirs all
+	$(INSTALL_PROGRAM) $(addprefix substituted/,$(PROGRAMS)) \
+		$(DESTDIR)$(bindir)
+	$(INSTALL_PROGRAM) $(addprefix absurd/,$(ABSURDITIES)) \
+		$(DESTDIR)$(absurddir)
 	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)
 	$(INSTALL_DATA) $(MAN7PAGES) $(DESTDIR)$(man7dir)
+	$(INSTALL_DATA) $(TXTDOCS) $(DESTDIR)$(txtdocdir)
 	set -e; for m in $(PERLMODULES); do \
 		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
 	done
@@ -54,6 +76,7 @@
 installdirs:
 	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
 		$(DESTDIR)$(man1dir) $(DESTDIR)$(man7dir) \
+		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
 		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))
 
 install-infra:	installdirs-infra
@@ -72,4 +95,12 @@
 check installcheck:
 
 clean distclean mostlyclean maintainer-clean:
-	rm -rf tests/tmp
+	rm -rf tests/tmp substituted
+	set -e; for m in $(MAN7PAGES); do \
+		test -e $$m.pod && rm -f $$m; \
+	done
+
+%.7: %.7.pod
+	pod2man --section=7 --date="Debian Project" --center="dgit" \
+		--name=$(subst .7,,$@) \
+		$^ $@

=== debian/changelog ===
dgit (2.13) unstable; urgency=high

  Changed behaviour:
  * quilt fixup: Permit creation of patches which delete files, by psssing
    --include-removal to dpkg-source, and tolerating it when we do our
    quilt fixup analysis.  dpkg-source has supported this since at least
    stretch.  Closes:#848901.

  Error messages:
  * Improve "cannot represent change" message: print the git old and new
    modes too.

  Bugfix:
  * Import: Switch back to unpa branch on patch import iterations.
    In particular, do not fail utterly if dpkg-source and gbp disagree.
    Closes:#848843.

  Documentation [Sean Whitton]:
  * dgit-maint-gbp(7): Remove reference to closed bug.  Closes:#848725.
  * dgit-sponsorship(7): Update in light of fixed #844129.  Closes:#848789.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 21 Dec 2016 01:32:41 +0000

dgit (2.12) unstable; urgency=high

  Changed behaviours:
  * By default, generate a DEP-14 tag as well as a dgit archive/*
    tag, even in non-split-view quilt modes.  Closes:#844129.
  * Version tags mangling: Protect dots, as per proposed update to DEP-14.

  Documentation:
  * dgit-maint-merge(7): Explain how to change to this workflow
    from an existing git workflow.  [Sean Whitton]  Closes:#847807.
  * dgit-maint-native(7): Clarify that we mean native source format.
    [Phil Hands]  Closes:#847987.

  Error messages:
  * Slightly better message when .dsc not found.  Apropos of #844128.
  * Give better advice if .dsc/.changes signing fails: if no changes
    are needed to the package, user may indeed just debsign and dput.
    Closes:#844131.
  * Produce better error reporting when absurd git wrapper fails
    on a patch during .dsc import.  Apropos of #848391.

  Bugfixes:
  * If we cannot hardlink origs into our extraction area, use symlinks
    instead.  Closes:#844570.
  * Suppress some leftover debugging output from import-dsc.
    Closes:#847658.
  * Do not fail when cloning a package containing dangling symlinks.
    Closes:#848512.
  * Do not fail to import a .dsc containing patches which patch files
    multiple times, due to #848611.  Closes:#848391.
  * Do not fail to import a .dsc containing patches to .git/ (!)
  * infra: dgit-repos-policy-debian which broke due to recent git setting
    GIT_ALTERNATE_OBJECT_DIRECTORIES in the pre-receive-hook.
    (fixes test suite regression in stretch).

  Test suite:
  * Provide and use stunt lintian and debuild, to avoid lintian
    complaining about our stupid test packages.
    (fixes test suite regression in stretch).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 19 Dec 2016 17:35:18 +0000

dgit (2.11) unstable; urgency=medium

  Documentation:
  * dgit-user(7): Better explanation of combined suites (comma syntax).
    Thanks to Sean Whitton for review and suggestions.
  * dgit(1), dgit(7): Better reference docs for combined suites.
  * dgit(1): Improve formatting of rpush section.

  Test suite:
  * Replace make in Test-Depends with build-essential.  Most of the tests
    do in fact run dpkg-buildpackage which bombs out if build-essential is
    missing.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 08 Nov 2016 22:41:29 +0000

dgit (2.10) unstable; urgency=medium

  New features:
  * Support the Debian *-security suites.
  * New comma-separated multiple-suite merging facility (readonly),
    so that users can easily track "jessie, or jessie-security".
  * dgit-user(7): Suggest `dgit clone P jessie,-security'.

  Bugfixes:
  * Cope when an orig tarball is a tarbomb.  Ie, if it contains
    other than one single directory toplevel.  Closes:#843422.
  * Actually honour the branch name, if we are on dgit branch, to specify
    the suite, as documented in the manpage.
  * When cloning a distro which has no git server, correctly leave
    the user on the local dgit branch, not on `master'.
  * Fix an unconditional print that was supposed to be a printdebug:
      origs <blah>.orig.tar.gz f.same=1 #f._differ=-1
  * Print a slightly better message if .git found in orig tarball(s).

  Test suite:
  * Test suite: Add fakeroot and make to Test-Depends.  These aren't
    necessarily pulled in by anything else.  (dpkg-dev Recommends
    build-essential.  But we don't actually need build-essential.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 08 Nov 2016 01:08:51 +0000

dgit (2.9) unstable; urgency=medium

  New features:
  * During push, automatically calculate which .origs are required,
    so user never needs [--ch:]-sa or [--ch:]-sd.  Closes:#829116.
  * New import-dsc feature.
  * New option --dgit-view-save= for split view quilt modes.
    In particular, means that the output of a split view quilt-fixup
    is left somewhere useful.
  * dgit clone: Set timestamps in cloned tree to a single unified time.
    This makes it less likely that the user will trip over any
    timestamp-dependent FTBFS bugs (eg #842452).
  * Support dgit --delayed= push (with a warning in the manpage
    about possible skew).
  * dgit gbp-build will arrange to let gbp buildpackage generate
    .orig tarballs if it seems applicable.  Closes:#841094.

  Documentation improvements:
  * dgit-*(7).  Many new tutorial manpages, several written and many
    improved by Sean Whitton.
  * dgit(7): Substantial updates, including documenting split view.
  * dgit(1): Better cross-references.
  * dgit(1): Remove obsolete workflow information.
  * dgit(1): Improved BUGS section.
  * Fix changelog entry for SIGPIPE to correctly mention
    Closes:#841090.

  Bugfixes:
  * Split brain mode: Fix --new.  Closes:#842577.
  * Properly look for .origs etc. in .., fetching them less often.
    Closes:#842386.
  * Reject `dgit pull' in split view quilt modes, to avoid
    creating unfortunate wreckage on non-dgit-view branches.
    Closes:#842608.
  * Cope when cloning suite which doesn't receive uploads,
    like testing.  Closes:#842621.
  * Properly fetch all archive dgit view tags, as we intended.


=== debian/control ===
--- 
+++ 
@@ -10,11 +10,12 @@
 
 Package: dgit
 Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
-         ${misc:Depends},
+         ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
          coreutils (>= 8.23-1~) | realpath,
-         libdigest-sha-perl, dput, curl,
-         libjson-perl, ca-certificates
-Recommends: ssh-client
+         libdigest-sha-perl, dput, curl, apt,
+         libjson-perl, ca-certificates,
+         libtext-iconv-perl, libtext-glob-perl
+Recommends: ssh-client, libtext-iconv-perl
 Suggests: sbuild
 Architecture: all
 Description: git interoperability with the Debian archive
@@ -26,10 +27,13 @@
  dgit clone and dgit fetch construct git commits from uploads.
 
 Package: dgit-infrastructure
-Depends: ${misc:Depends}, perl, git-core, dgit, gpgv, chiark-utils-bin,
-         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3
+Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
+         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,
+         libwww-perl, libdpkg-perl
+Recommends: dgit
 Architecture: all
 Priority: extra
 Description: dgit server backend infrastructure
  This package contains tools which are useful for setting up a dgit
- git repository server.  You probably want dgit, the client package.
+ git repository server.  You probably want dgit, the client package,
+ instead of dgit-infrastructure.

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, git-buildpackage

Tests: clone-reprepro
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, reprepro

Tests: dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, rsync

Tests: build-modes-sbuild quilt-gbp-build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, sbuild
Restrictions: x-dgit-schroot-build

Tests: spelling
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential
Restrictions: x-dgit-git-only

Tests: absurd-gitapply build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp distropatches-reject drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig import-dsc import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version push-buildproductsdir push-newpackage push-nextdgit quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential

## dgit 3.9~bpo8+1

=== debian/changelog ===
dgit (3.9~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 04 Feb 2017 17:38:33 -0700

dgit (3.9) unstable; urgency=medium

  Improvements:
  * dgit --overwrite: Check that the overwritten version's changelog entry
    is not UNRELEASED.  This could easily happen if this release was being
    made from a git branch which predates the previous package upload.

  Documentation:
  * dgit-maint-merge(7): Get git clone url right.  Closes:#852609.
  * dgit-maint-merge(7): Quote sample clone commands.  Closes:#852615.

  Test suite:
  * overwrite-chkclog: test UNRELEASED handling.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 25 Jan 2017 16:21:53 +0000

dgit (3.8) unstable; urgency=medium

  Bugfixes:
  * Make dgit-setup-* work in default distro.

  Test suite:
  * defdistro-setup: Test that setup-* functions distro selection works.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 23 Jan 2017 16:21:30 +0000

dgit (3.7) unstable; urgency=medium

  Bugfixes:
  * Fix clone-dgit-repos-server and print-dgit-repos-server-print-url.
    Closes:#851906.

  Documentation:
  * dgit-maint-merge(7): Explain when workflow is unsuitable
    (Closes:#852090) and improve the patch-header (Closes:#851897.)

  Internal changes:
  * New %.view target: `make dgit-maint-merge.7.view' runs `man -l ...'

  Test suite:
  * defdistro-dsd-clone-drs: New test which would have detected
    #851906 (and hopefully #850521).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Jan 2017 17:30:24 +0000

dgit (3.6) unstable; urgency=medium

  Bugfixes:
  * Actually use the url from a Dgit .dsc field naming an unknown distro.
    Closes:#851728.
  * Add dummy implementation of file_in_archive_aptget copied from
    file_in_archive_dummycat.  Re:#851697.   [ Peter Green ]

  Minor improvements:
  * Use `confess' to print a stack trace in a couple of internal error
    rcases.

  Infrastructure:
  * Properly honour NOCOMMITCHECK policy hook exit status.
    Closes:#851800.
  * Do not reject commits with no author/committer name (but still insist
    on email address and date).  Peter Green reports that eg
    71e128629ec786f3 in upstream xen.git is such a commit (and is accepted
    by github).  Closes:#851716.

  Test suite:
  * downstream-gitless: Test import of .dsc from unknown distro.
  * downstream-gitless: Test import of .dsc with unsafe url.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 19 Jan 2017 01:15:03 +0000

dgit (3.5) unstable; urgency=medium

  Bugfixes:
  * gitattributes: Defuse gitattributes in private working area even if we
    don't do it in the user's tree (because of user configuration).
  * gitattributes: When cloning, do not print spurious warning about
    actually-defused gitattributes.  Closes:#851624.
  * gitattributes: Improve comment left in .git/info/attributes.

  Test suite:
  * gitattributes: Many improvements to test case.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 17 Jan 2017 22:36:01 +0000

dgit (3.4) unstable; urgency=low

  Test suite:
  * drs-push-rejects: Set origin's url to an ad-hoc expression
    which produces the right ext:: rune, as dgit would.
    Closes:#851580.
  * Replace references to /home/ian in various worktrees with
    references to /nonexistent, to catch inadvertant accesses.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 16 Jan 2017 17:27:35 +0000

dgit (3.3) unstable; urgency=medium

  Behavioural changes to work around gitattributes file transformations:
  * Suppress file-transforming gitattributes in private work areas.
  * Configure suppression in user's trees in dgit clone and setup-new-tree.
  * Provide dgit setup-gitattributes to do this explicitly.
  * Documentation.

  Bugfixes:
  * dgit: Remove a leftover debugging print.
  * dgit: Set default dsc import distro when there is no Dgit field.
  * dgit: Set default dsc import distro when suppressing Dgit field.
  * dgit: Option parsing: Fix undefined $suite in some import-dsc.
    Closes:#851213.

  Packaging:
  * Remove redundant use of List::Util qw(any).  Closes:#851280.
  * Remove redundant Recommends on libtext-iconv-perl.

  Test suite:
  * Move default dsc distro config setting to lib.  We need this
    for the .dscs we have in tests/pkg-srcs/.
  * defdistro-import-dsc: Drop this test.
  * protocol-compat: check that we use the right distro
    information when importing.
  * Internal change: fix handling of nonempty distro=
  * gitattributes: New test for .gitattributes handling.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 16 Jan 2017 10:03:08 +0000

dgit (3.2) unstable; urgency=medium

  Bugfixes:
  * dgit: Do not execute END blocks in children.  So far symptoms of this
    bug seem to be limited to duplicated error messages but I have not
    done a thorough analysis.  Closes:#850052.
  * dgit-infrastructure: dgit-repos-policy-debian: Remirror a package when
    it becomes public (ie, make the repo available much more promptly when
    the package passes NEW).  Closes:#849789.
  * dgit: Fix a warning message about ref (mainly, tag) updates.

  Documentation:
  * dgit-maint-merge(7): Use git-deborig(1).
    [Sean Whitton]  Closes:#850953.
  * dgit-user(7): Fix some typos.

  Internals:
  * Fix a typo in a comment.

  Test suite:
  * infra: mirroring and policy hooks: Improve some debugging output.
  * infra: mirror-private: test that package becomes public.  (#849789)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 12 Jan 2017 02:11:34 +0000

dgit (3.1) unstable; urgency=medium

  Bugfixes:
  * dgit import-dsc: Do not crash with undefined $isuite.  Closes:#850781.
  * dgit build: Do not sometimes crash with undefined $isuite.
  * dgit: Do not nedlessly re-fetch the rewrite map.
  * dgit: After downloading .debian.* files, save them in `..', too
    (ie do this not just for .origs).
